/**
 * @brief demo application for the library
 * @author Christian Burger (christian@krikkel.de)
 */

#ifndef A3B2AE4E_0A39_468C_8CCA_E6508166702A
#define A3B2AE4E_0A39_468C_8CCA_E6508166702A

#include <cursesapp.h>
#include <mutex>

namespace krikkel::NCurses
{
    class VerticalTilingWindowManager;
    class HorizontalTilingWindowManager;
    class Window;
    class PtyWindow;

    class DemoApp : public NCursesApplication
    {
        public:
            DemoApp();

        private:
            VerticalTilingWindowManager *windowManager;
            HorizontalTilingWindowManager *topWindowManager, *bottomWindowManager;
            Window *dummyWindowTopLeft, *dummyWindowTopRight
                 , *dummyWindowBottomLeft, *dummyWindowBottomRight;
            PtyWindow *ptyWindow;
            std::recursive_mutex ncursesMutex;

            int run() override;
            void setUpWindows();
            void forkShell();
            void mainLoop();
    };
}

#endif /* A3B2AE4E_0A39_468C_8CCA_E6508166702A */
